/*

The Life of a Geek
Copyright (C) 2003 Daniel Quintiliani

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

You can e-mail Daniel Quintiliani at coredump@coredumpcentral.org

main.cc - Main program.

6/14/03: Daniel Quintiliani <coredump@coredumpcentral.org>: Fixed support for
older compilers/C libraries.
6/13/03: Daniel Quintiliani <coredump@coredumpcentral.org>: Added elapsed time
code, updated handling of geek's name, made virus point deduction more random,
if you run out of energy and fall asleep, the screen pauses.
5/21/03: Daniel Quintiliani <coredump@coredumpcentral.org>: Updated virus point
deduction code.
5/20/03: Daniel Quintiliani <coredump@coredumpcentral.org>: main.lg used now
instead of game.lg.
4/24/03: Daniel Quintiliani <coredump@coredumpcentral.org>: Fixed a bug where
you would be stuck if you had no energy and no money instead of falling asleep.
Text file game.lg now used.
4/7/03: Daniel Quintiliani <coredump@coredumpcentral.org>:
gpl_check_and_strlwr() put in, now you can enter name of geek,
to be more considerate replaced all bools with ints, added
object of game into game.
 
*/

#include "func.h"
#include <iostream>
#include <math.h>
#include "display.h"

using namespace std;

int main()
{
	string s = "show w", s2 = "show w";
	Computer comp;
	Geek geek;
	ElTime elt;
	
	cout << readfromfilevars(MAINFILE,"!INTRO",0,geek,comp,elt,0,0,"","","");	

	while(s2 == "show w" || s2 == "show c" )
	{
		cout << readfromfile(MAINFILE,"!PNAME",1);
		getline(cin, s2);
		string geekname;
		geekname = s2.c_str();
		gpl_check_and_strlwr(s2);
		if(geekname=="")
			geek.SetName("Geek");
		else
			geek.SetName(geekname.c_str());
		cout << endl;
	}

	while(s[0] != 'i')
	{
		cout << readfromfile(MAINFILE,"!MAINMENU",0);	

		while(s == "show w" || s == "show c" )
		{
			cout << readfromfile(MAINFILE,"!PENTER",1);
			getline(cin, s);
			gpl_check_and_strlwr(s);
			cout << endl;
		}
			
		if(s[0] == 'a')	
			ShowStats(geek, comp,elt);
		else if(s[0] == 'b')
			SpeedClass(geek, comp,elt);
		else if(s[0] == 'c')	
			Work(geek, comp,elt);
		else if(s[0] == 'd')	
			Caff(geek,elt);
		else if(s[0] == 'e')	
			Hack(geek, comp,elt);
		else if(s[0] == 'f')	
			AntiVirus(geek, comp,elt);
		else if(s[0] == 'g')	
			WasteTime(geek,comp,elt);
		else if(s[0] == 'h')	
			Sleep(geek, comp,elt);
		else if(s[0] == 'i')	
			cout << "\nNot written yet." << endl;
		
		if(s[0] != 'i')
		{
			if( comp.GetHealth() < comp.GetMaxHealth() )
				comp.SetHealth(comp.GetHealth() + 1);
			
			if( comp.GetInfected() == 0)
			{
				srand((unsigned)time(NULL));
				float f = 1 + ((float)
					(comp.GetMaxHealth() / 2) * 
				     rand() / RAND_MAX - comp.GetSecurity()); 
				int n = (int)roundf(f);
				if(n>(comp.GetMaxHealth()/2)) n=comp.GetMaxHealth()/2;
				if(n<0)n=0;
				comp.SetHealth(comp.GetHealth() - n);
				cout << readfromfilevars(MAINFILE,"!LOSTPTS",0,geek, comp, elt,n,0, "", "","");
			}
			
			if( comp.GetHealth() <= 0 )
			{
				cout << readfromfile(MAINFILE,"!LOSER",0);
				return 0;
			}
			
			if( geek.GetEnergy() <= 0 )
			{
				string stemp;
				cout << readfromfile(MAINFILE,"!FALLASLP",0);
				CmdSleep(geek,comp,elt);
				cout << readfromfile(MAINFILE,"!PAUSE",0);
				getline(cin,stemp);
			}
			if(comp.GetHealth() == comp.GetMaxHealth() && comp.GetInfected() != 0 && geek.GetEducation() >= 40 )
			{
				cout << readfromfile(MAINFILE,"!WINNER",0);
				return 0;
			}
			
			s = "show w";
		
		}		
	}
	
	return 0;
}
